VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmFileListBuild 
   Caption         =   "Create File List"
   ClientHeight    =   5085
   ClientLeft      =   45
   ClientTop       =   360
   ClientWidth     =   11250
   OleObjectBlob   =   "frmFileListBuild.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmFileListBuild"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'''''''''''''''''''''''''''
'This UserForm is designed to let the user select a batch of files
'from multiple directories to be processed by some macro.
'It is designed for SolidWorks, but can be easily changed to any other program.
'As written it requires a reference to the Microsoft Excel object library as well.
'
'Usage:  Import the form into a macro.  Following is a minimal sub showing usage:
'
'Sub main()
'Dim myRtn As Variant 'Must be variant to recieve array of unknown size
'frmFileListBuild.Show  'Show the form. This code will pause while form is visible.
'myRtn = frmFileListBuild.lstFileNames.List 'Form is loaded but not visible.  ListBox can be accessed.
'Unload frmFileListBuild  'Unload the form and clear memory
''You must check to see if the return is an array to know if any files were selected:
'If IsArray(myRtn) Then
'    MsgBox "You selected " & UBound(myRtn) + 1 & " files for processing!"
'Else
'    MsgBox "No files selected"
'End If
'End Sub


Const EXCELFILTERSTRING As String = "SolidWorks Files (*.sld*),*.sld*,Parts (*.sldprt),*.sldprt,Assemblies (*.sldasm),*.sldasm,Drawings (*.slddrw),*.slddrw,All Files (*.*),*.*"
Const SWFILTERSTRING As String = "SW Files|*.sldprt; *.sldasm; *.slddrw|Parts|*.sldprt|Assemblies|*.sldasm|Drawings|*.slddrw|All Files|*.*|"

Private Sub btnCancel_Click()
    'Clear the list box so that it is empty when queried by the calling code
    Me.lstFileNames.Clear
    Me.Hide
End Sub

Private Sub btnRem_Click()

'This sub simply loops thru the entries in the list,
'deleting any that are selected.

Dim i As Long
Dim ListLen As Long
i = 0
ListLen = Me.lstFileNames.ListCount
While i < ListLen
    If Me.lstFileNames.Selected(i) Then
        Me.lstFileNames.RemoveItem (i)
        ListLen = Me.lstFileNames.ListCount
        'If the item is removed, "i" stays the same
    Else
        i = i + 1
    End If
Wend
    
End Sub

Private Sub btnAdd_Click()
Dim j As Long
Dim AlreadyInList As Boolean
Dim swApp As SldWorks.SldWorks
Set swApp = Application.SldWorks

If Me.chkMultiSel Then 'Use Excel to select
    Dim myXL As Excel.Application
    Dim i As Long
    Dim SaveDefaultPath As String
    Dim PickedFiles As Variant
    
    ''''''
    'This sets the starting directory for the "open" dialog
    'to be the current SW working directory.  However, this change
    'only works for the next instance of Excel that starts.
    'So we change it and then change it back.
    Set myXL = New Excel.Application
    SaveDefaultPath = myXL.DefaultFilePath  'memorize current default
    myXL.DefaultFilePath = swApp.GetCurrentWorkingDirectory 'set new default
    Set myXL = Nothing 'Close Excel to save this change
    Set myXL = New Excel.Application  'Open Excel again
    PickedFiles = myXL.GetOpenFileName(EXCELFILTERSTRING, , "Choose Files...", , True)
    'PickedFiles now contains an array of filenames.
    myXL.DefaultFilePath = SaveDefaultPath  'Set default path back like it was
    Set myXL = Nothing   'Close Excel
    
    'Add files from the array to the list box, checking each one
    'to see if it is already present before adding it.
    ''!!!STRANGE NOTE: Excel seems to return a 1-based array rather than zero-based!
    If IsArray(PickedFiles) Then
        For i = 1 To UBound(PickedFiles)
            AlreadyInList = False
            For j = 0 To Me.lstFileNames.ListCount - 1
                If UCase(PickedFiles(i)) = UCase(Me.lstFileNames.List(j, 0)) Then
                    AlreadyInList = True
                End If
            Next j
            If Not AlreadyInList Then
                Me.lstFileNames.AddItem PickedFiles(i)
            End If
        Next i
    End If
Else  'Multi-Select was not picked.  Use the SolidWorks GetOpenFileName dialog.
    Dim PickedFile As String 'Only one file this time
    PickedFile = swApp.GetOpenFileName("Choose File...", Empty, SWFILTERSTRING, Empty, Empty, Empty)
    If (PickedFile <> Empty) And (PickedFile <> "") Then
        AlreadyInList = False
        For j = 0 To Me.lstFileNames.ListCount - 1
            If UCase(PickedFile) = UCase(Me.lstFileNames.List(j, 0)) Then
                AlreadyInList = True
            End If
        Next j
        If Not AlreadyInList Then
            Me.lstFileNames.AddItem PickedFile
        End If
    End If
End If
End Sub

Private Sub btnOK_Click()

'Hide this form.  The list box still contains the list of files,
'and the calling code can access the list.

Me.Hide
End Sub



